<?php
//CKEditor RichText Editor Plugin v3.1-alpha

// getCKEditorSettings function
if (!function_exists('getCKEditorSettings'))
{
	function getCKEditorSettings($_lang,
	                             $path,
	                             $manager_language='english',
	                             $use_editor,
	                             $toolbarset,
	                             $toolbarcustom,
	                             $autolang,
	                             $displayStyle,
	                             $xmlstyle)
	{
		// language settings
		if(!@include_once($path.'/lang/'.$manager_language.'.inc.php'))
		    @include_once($path.'/lang/english.inc.php');

		$display = $use_editor==1 ? $displayStyle : 'none';

		$arrToolbar['modx']    = $_lang['ckeditor_toolbar_modx'];
		$arrToolbar['full'] = $_lang['ckeditor_toolbar_full'];
		$arrToolbar['simple'] = $_lang['ckeditor_toolbar_simple'];
		foreach ($arrToolbar as $key=>$value)
		{
				$toolbarOptions .= "					<option value=\"".$key."\"".($key == $toolbarset ? " selected=\"selected\"" : "").">".$value."</option>\n";
		}
		$xmlstyle = !empty($xmlstyle) ? htmlspecialchars($xmlstyle) : "";

		$str = '		<table id="editorRow_CKEditor" style="width:inherit;" border="0" cellspacing="0" cellpadding="3">' . PHP_EOL;
		$str .= '		  <tr class="row1" style="display: ' . $display . ';">' . PHP_EOL;
		$str .= '            <td colspan="2" class="warning" style="color:#707070; background-color:#eeeeee"><h4>' . $_lang["CKEditor_settings"] . '<h4></td>' . PHP_EOL;
		$str .= '          </tr>' . PHP_EOL;
		$str .= '          <tr class="row1" style="display: ' . $display . '">' . PHP_EOL;
		$str .= '            <td nowrap class="warning"><b>' . $_lang["ck_editor_toolbar_title"] . '</b></td>' . PHP_EOL;
		$str .= '            <td>' . PHP_EOL;
		$str .= '            <select name="ck_editor_toolbar" onChange="documentDirty=true;">' . PHP_EOL;
		$str .= $toolbarOptions . PHP_EOL;
		$str .= '			</select>' . PHP_EOL;
		$str .= '			</td>' . PHP_EOL;
		$str .= '          </tr>' . PHP_EOL;
		$str .= '          <tr class="row1" style="display: ' . $display . '">' . PHP_EOL;
		$str .= '            <td width="200">&nbsp;</td>' . PHP_EOL;
		$str .= '            <td class="comment">' . $_lang["ck_editor_toolbar_message"] . '</td>' . PHP_EOL;
		$str .= '          </tr>' . PHP_EOL;
		$str .= '		  <tr class="row1" style="display: ' . $display . '">' . PHP_EOL;
		$str .= '            <td colspan="2"><div class="split"></div></td>' . PHP_EOL;
		$str .= '          </tr>' . PHP_EOL;
		$str .= '		</table>' . PHP_EOL;
		$str .= '<script>' . PHP_EOL;
		$str .= 'alert(' . $toolbarset . ');' . PHP_EOL;
		$str .= '</script>' . PHP_EOL;
return $str;
	}
}

// getTinyMCEScript function
if (!function_exists('getCKEditorScript'))
{
	function getCKEditorScript($elementList,
	                           $toolbarset,
	                           $toolbarcustom,
	                           $width,
	                           $height,
	                           $language,
	                           $frontend,
	                           $base_url,
	                           $editor_css_path,
	                           $use_browser,
	                           $autoLang,
	                           $editorstyle,
	                           $pluginfolder,
	                           $webuser)
	{
	    $cke_path = $base_url. 'assets/plugins/' . $pluginfolder;
		$editor_css_path = !empty($editor_css_path) ? $editor_css_path : $cke_path . '/editor/css/ck_editorarea.css';
		$width = (!empty($width)) ? str_replace("px","",$width) : "100%";
		$height = (!empty($height)) ? str_replace("px","",$height) : "400";

		if($frontend=='false' || ($frontend=='true' && $webuser))
		{
			if($use_browser==1)
			{
				$allowrb = true;
			}
		}

		// build ck instances
        $elementList = explode(",",$elementList);
        $connector_path = $base_url . 'manager/media/browser/mcpuk/connectors/php/connector.php';
        $cke_query = '?Connector=' . $connector_path . '&ServerPath=' . $base_url . '&editor=tinymce3&editorpath=' . $cke_path;
        $mcpuk_path['base']  = $base_url . 'manager/media/browser/mcpuk/browser.php' . $cke_query ;
		$mcpuk_path['image'] = $mcpuk_path['base'] . '&Type=images';
		$mcpuk_path['flash'] = $mcpuk_path['base'] . '&Type=flash';
		$mcpuk_path['link']  = $mcpuk_path['base'] . '&Type=files';
		foreach($elementList as $ckInstance)
		{
			$ckInstances .= "<script language='javascript' type='text/javascript'>" . PHP_EOL;
			$ckInstances .= "CKEDITOR.replace( '" . $ckInstance . "'," . PHP_EOL;
			$ckInstances .= "{" . PHP_EOL;
			$ckInstances .= "filebrowserBrowseUrl      : '" . $mcpuk_path['base'] . "'," . PHP_EOL;
			$ckInstances .= "filebrowserImageBrowseUrl : '" . $mcpuk_path['image'] . "'," . PHP_EOL;
			$ckInstances .= "filebrowserFlashBrowseUrl : '" . $mcpuk_path['flash'] . "'," . PHP_EOL;
			$ckInstances .= "baseHref     : '" . MODX_SITE_URL . "'," . PHP_EOL;
//			$ckInstances .= "format_tags     : 'p;h2;h3;pre'," . PHP_EOL;
			$ckInstances .= "customConfig : '" . $base_url . 'assets/plugins/' . $pluginfolder . "/custom_config.php'" . PHP_EOL;
			$ckInstances .= '}' . PHP_EOL;
			$ckInstances .= ' );' . PHP_EOL;

			$ckInstances .= "</script>" . PHP_EOL;
		}

$script = <<<CK_SCRIPT
		<script language="javascript" type="text/javascript" src="{$base_url}assets/plugins/{$pluginfolder}/ckeditor/ckeditor.js"></script>
		<script language="javascript" type="text/javascript">
			function CKeditor_OnComplete(edtInstance) {
				if (edtInstance){ // to-do: add better listener
					edtInstance.AttachToOnSelectionChange(tvOnCKChangeCallback);
				}
			};

			function tvOnCKChangeCallback(edtInstance) {
				if (edtInstance) {
					elm = edtInstance.LinkedField;
					if(elm && elm.onchange) elm.onchange();
				}
			}
		</script>
{$ckInstances}
CK_SCRIPT;

		return $script;
	}
}
?>